/********************************************************************************
** CIS 15 BG-03
** Winter, 2004
***************
**
** Lab 3     Two-Dimensional Arrays        20 Points
**
****************************************************

  Reading Assignment: Page 402, Programming Example - Calculate Averages

  Write a program to keep records and perform statistical analysis for a 
  class of students. The class may have up to 45 students 
  (validation required: see Line 70, page 368). 
  
  There are five quizzes during the quarter. Each student is identified 
  by a personal identification number (PIN) of four digits.

  Input : Read data from a text file. The text file has the following format:
    
        3

        1110    78    55    80   100    86
        1111    67    78    45    89    35
        1112    23    66    78    79    90

  3 - represents the number of students in the class;
  1110 - represents the Personal Identification Number of a student; it is 
  followed by 5 integers representing the quiz scores.

  Output: Write the output to another text file (see the example below).  
	      The output is to contain:

      1. Students' statistics (lowest score, largest score, sum, and average)
              
      2. Quizzes' statistics (lowest score, largest score, sum, and average).
              
      3. Class average. 


  Data: Run your program once, using SCORES.TXT

  Example: If the data file contains data for two students 
  the output should be:

  STUDENTS: Statistical Analysis

  PIN    Quiz1  Quiz2  Quiz3  Quiz4  Quiz5 | Low   High   Sum    Ave
  ====   =====  =====  =====  =====  ===== | ====  ====  ====  =====
  1019	    90	   80	  85	100	    60 |   60   100   415   83.0 
  1178	    82	   90	  90	 45	    89 |   45    90   396   79.2 
  ==================================================================

  QUIZZES: Statistical Analysis

  PIN	 Quiz1  Quiz2  Quiz3  Quiz4  Quiz5 
  ====   =====  =====  =====  =====  ===== 
  1019      90     80     85    100     60	 
  1178	    82	   90	  90     45	    89	 
        _______________________________________

  Low       82     80     85     45     60          
  High      90     90     90    100     89
  Sum      172    170    175    145    149
  Ave       86.0   85.0   87.5   72.5   74.5
  =======================================================

  CLASS AVERAGE: 81.10 
                  
****************************************
**
**  Written By:  ???
**
**  Date: 1/26/02 - ??/??/02  
**
********************************************************************************/
#include <stdio.h>

#define MAX_ROWS 46
#define MAX_COLS 6

/* Prototype Declarations */
int  getData (int table [] [MAX_COLS]);
void columnAverage (int table[] [MAX_COLS], float colAvrg [], int totalStudents);
void rowAverage (int table[] [MAX_COLS], float rowAvrg [], int totalStudents);
void printTables (int table[] [MAX_COLS], float rowAvrg[], float colAvrg[], int totalStudents);
void welcome  (void);
void farewell (void);

int main (void)
{
/* Local Definitions */
int table [MAX_ROWS] [MAX_COLS];
float rowAve [MAX_ROWS] = {0};
float columnAve [MAX_COLS] = {0};
int totalStudents = 0;

/* Statements */
   welcome ();
   totalStudents = getData (table);
   columnAverage (table, columnAve, totalStudents);
   rowAverage (table, rowAve, totalStudents);
   printTables (table, rowAve, columnAve, totalStudents);
   farewell ();

   return 0;

} /* main */


/* ============================== welcome ==============================
	Prints a welcome message.
	   PRE  : nothing
	   POST : welcome message printed
*/
void welcome (void)
{
/*  Local Definitions */

/*  Statements */
	printf("\t\t LAB 3 - Two-Dimensional Arrays\n\n");
	
	return;

} /* welcome */

/* ============================== farewell ==============================
	Prints a farewell message.
	   PRE  : nothing.
	   POST : farewell message printed
*/
void farewell (void)
{
	printf("\n\t\tEnd of the program!"
		   "\n\t\tHave a great day!\n");

	return;

} /* farewell */

/* ==================== getData ====================
Read data from file into array. The array
does not have to be completely filled.
Pre data is an empty array
size is maximum elements in array
range is highest value allowed
Post array is filled. Return number of elements
*/

int getData (int table [] [MAX_COLS])
{
	/* Local Definitions */
	int totalStudents = -1;
	int dataIn;
	int loader = 0; 
	int row;
	int col;
	int colCounter = 0;
	FILE *fpData;
	
	/* Statements */
	
	if (!(fpData = fopen ("scores.txt", "r")))
	{
		printf("Error opening file\a\a\n");
	}
	
	while (fscanf(fpData, "%d", &dataIn) != EOF)
	{
		++colCounter;
		if (colCounter == 1 && totalStudents == -1)
  		{
  			totalStudents = dataIn;
  			printf("\nTotal students: %d\n", totalStudents);
  			continue;
		}
		if (colCounter == 2 || (colCounter % 6) == 1)
			continue;
  			
		for (row=0; row < totalStudents; row++)
		{
			for (col = 0; col < (MAX_COLS - 1); ++col)
			{
				/*if (dataIn >= 0 && dataIn <= range)*/
					table [row] [col] = dataIn;
				/*else
					printf("\nData point %d invalid. Ignored. \n", dataIn);*/
				if (fscanf(fpData, "%d", &dataIn) == EOF) {
				    return totalStudents;
			 	} else {
					++colCounter;
					if (colCounter == 2 || (colCounter % 6) == 2)
					{
						if (fscanf(fpData, "%d", &dataIn) == EOF)
							return totalStudents;
			 			++colCounter;
			 		}
		 		}
			}
		}
	}

	return totalStudents;
}
/* getData */

/* ==================== columnAverage ====================
This function calculates the average for the columns.
Pre table has been filled with integer values
Post average calculated and put in the average array
*/
void columnAverage (int table [] [MAX_COLS], float colAvrg[], int totalStudents)
{
	/* Local Definitions */
	int row;
	int col;
	/* statements */
	for (col = 0; col < (MAX_COLS - 1); col++)
	{
		for (row = 0; row < totalStudents; row++)
			colAvrg [col] += table [row][col];
		colAvrg [col] /= totalStudents;
	} /* for col */
	return;

} /* columnAverage */

/* ==================== row Average ====================
This function calculates the row averages for a table
Pre table has been filled with values
Post averages calculated & put in the average array.
*/
void rowAverage (int table [] [MAX_COLS], float rowAvrg [], int totalStudents)
{
	/* Local Definition */
	int row;
	int col;
	
	/* Statements */
	for (row = 0; row < totalStudents; row++)
	{
		for (col = 0; col < (MAX_COLS - 1) ; col++)
			rowAvrg[row] += table [row][col];
		rowAvrg [row] /= (MAX_COLS - 1);
	} /* for row */
	return;
} /* row Average */

/* ==================== printTables ====================
Print data table, with average of rows at end of each
row and average of columns below each column.
Pre each table has been filled with i~s data
Pos~ the tables have been printed.
*/
void printTables (int table[][MAX_COLS], float rowAvrg[], float colAvrg[], int totalStudents)
{
	/* Local Definitions */
	int row;
	int col;
	
	/* Statements */
	for (row = 0; row < totalStudents; row++ )
	{
		for (col = 0; col < (MAX_COLS - 1); col++)
			printf("%6d", table[row] [col]);
		printf(" || %6.2f\n", rowAvrg [row]);
	} /* for row */
	
	printf("==================================================================\n");
	for (col = 0; col < (MAX_COLS - 1); col++)
		printf("%6.2f", colAvrg[col]);
//	scanf("%d", &row);
	return;
} /* printTables */
/* ================ End of Program ================= */
